<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TypeDemarcheECG StructType
 * @subpackage Structs
 */
class TypeDemarcheECG extends AbstractStructBase
{
    /**
     * The VOF
     * Meta information extracted from the WSDL
     * - choice: VOF | VOI | VN | DUP | MCT
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\TypeEcgVOF
     */
    public $VOF;
    /**
     * The VOI
     * Meta information extracted from the WSDL
     * - choice: VOF | VOI | VN | DUP | MCT
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\TypeEcgVOI
     */
    public $VOI;
    /**
     * The VN
     * Meta information extracted from the WSDL
     * - choice: VOF | VOI | VN | DUP | MCT
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\TypeEcgVN
     */
    public $VN;
    /**
     * The DUP
     * Meta information extracted from the WSDL
     * - choice: VOF | VOI | VN | DUP | MCT
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\TypeEcgDuplicata
     */
    public $DUP;
    /**
     * The MCT
     * Meta information extracted from the WSDL
     * - choice: VOF | VOI | VN | DUP | MCT
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\TypeEcgMCT
     */
    public $MCT;
    /**
     * Constructor method for TypeDemarcheECG
     * @uses TypeDemarcheECG::setVOF()
     * @uses TypeDemarcheECG::setVOI()
     * @uses TypeDemarcheECG::setVN()
     * @uses TypeDemarcheECG::setDUP()
     * @uses TypeDemarcheECG::setMCT()
     * @param \StructType\TypeEcgVOF $vOF
     * @param \StructType\TypeEcgVOI $vOI
     * @param \StructType\TypeEcgVN $vN
     * @param \StructType\TypeEcgDuplicata $dUP
     * @param \StructType\TypeEcgMCT $mCT
     */
    public function __construct(\StructType\TypeEcgVOF $vOF = null, \StructType\TypeEcgVOI $vOI = null, \StructType\TypeEcgVN $vN = null, \StructType\TypeEcgDuplicata $dUP = null, \StructType\TypeEcgMCT $mCT = null)
    {
        $this
            ->setVOF($vOF)
            ->setVOI($vOI)
            ->setVN($vN)
            ->setDUP($dUP)
            ->setMCT($mCT);
    }
    /**
     * Get VOF value
     * @return \StructType\TypeEcgVOF
     */
    public function getVOF()
    {
        return isset($this->VOF) ? $this->VOF : null;
    }
    /**
     * This method is responsible for validating the value passed to the setVOF method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVOF method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateVOFForChoiceConstraintsFromSetVOF($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'VOI',
            'VN',
            'DUP',
            'MCT',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property VOF can\'t be set as the property %s is already set. Only one property must be set among these properties: VOF, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set VOF value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TypeEcgVOF $vOF
     * @return \StructType\TypeDemarcheECG
     */
    public function setVOF(\StructType\TypeEcgVOF $vOF = null)
    {
        // validation for constraint: choice(VOF, VOI, VN, DUP, MCT)
        if ('' !== ($vOFChoiceErrorMessage = self::validateVOFForChoiceConstraintsFromSetVOF($vOF))) {
            throw new \InvalidArgumentException($vOFChoiceErrorMessage, __LINE__);
        }
        if (is_null($vOF) || (is_array($vOF) && empty($vOF))) {
            unset($this->VOF);
        } else {
            $this->VOF = $vOF;
        }
        return $this;
    }
    /**
     * Get VOI value
     * @return \StructType\TypeEcgVOI
     */
    public function getVOI()
    {
        return isset($this->VOI) ? $this->VOI : null;
    }
    /**
     * This method is responsible for validating the value passed to the setVOI method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVOI method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateVOIForChoiceConstraintsFromSetVOI($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'VOF',
            'VN',
            'DUP',
            'MCT',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property VOI can\'t be set as the property %s is already set. Only one property must be set among these properties: VOI, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set VOI value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TypeEcgVOI $vOI
     * @return \StructType\TypeDemarcheECG
     */
    public function setVOI(\StructType\TypeEcgVOI $vOI = null)
    {
        // validation for constraint: choice(VOF, VOI, VN, DUP, MCT)
        if ('' !== ($vOIChoiceErrorMessage = self::validateVOIForChoiceConstraintsFromSetVOI($vOI))) {
            throw new \InvalidArgumentException($vOIChoiceErrorMessage, __LINE__);
        }
        if (is_null($vOI) || (is_array($vOI) && empty($vOI))) {
            unset($this->VOI);
        } else {
            $this->VOI = $vOI;
        }
        return $this;
    }
    /**
     * Get VN value
     * @return \StructType\TypeEcgVN
     */
    public function getVN()
    {
        return isset($this->VN) ? $this->VN : null;
    }
    /**
     * This method is responsible for validating the value passed to the setVN method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVN method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateVNForChoiceConstraintsFromSetVN($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'VOF',
            'VOI',
            'DUP',
            'MCT',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property VN can\'t be set as the property %s is already set. Only one property must be set among these properties: VN, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set VN value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TypeEcgVN $vN
     * @return \StructType\TypeDemarcheECG
     */
    public function setVN(\StructType\TypeEcgVN $vN = null)
    {
        // validation for constraint: choice(VOF, VOI, VN, DUP, MCT)
        if ('' !== ($vNChoiceErrorMessage = self::validateVNForChoiceConstraintsFromSetVN($vN))) {
            throw new \InvalidArgumentException($vNChoiceErrorMessage, __LINE__);
        }
        if (is_null($vN) || (is_array($vN) && empty($vN))) {
            unset($this->VN);
        } else {
            $this->VN = $vN;
        }
        return $this;
    }
    /**
     * Get DUP value
     * @return \StructType\TypeEcgDuplicata
     */
    public function getDUP()
    {
        return isset($this->DUP) ? $this->DUP : null;
    }
    /**
     * This method is responsible for validating the value passed to the setDUP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDUP method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateDUPForChoiceConstraintsFromSetDUP($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'VOF',
            'VOI',
            'VN',
            'MCT',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property DUP can\'t be set as the property %s is already set. Only one property must be set among these properties: DUP, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set DUP value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TypeEcgDuplicata $dUP
     * @return \StructType\TypeDemarcheECG
     */
    public function setDUP(\StructType\TypeEcgDuplicata $dUP = null)
    {
        // validation for constraint: choice(VOF, VOI, VN, DUP, MCT)
        if ('' !== ($dUPChoiceErrorMessage = self::validateDUPForChoiceConstraintsFromSetDUP($dUP))) {
            throw new \InvalidArgumentException($dUPChoiceErrorMessage, __LINE__);
        }
        if (is_null($dUP) || (is_array($dUP) && empty($dUP))) {
            unset($this->DUP);
        } else {
            $this->DUP = $dUP;
        }
        return $this;
    }
    /**
     * Get MCT value
     * @return \StructType\TypeEcgMCT
     */
    public function getMCT()
    {
        return isset($this->MCT) ? $this->MCT : null;
    }
    /**
     * This method is responsible for validating the value passed to the setMCT method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMCT method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateMCTForChoiceConstraintsFromSetMCT($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'VOF',
            'VOI',
            'VN',
            'DUP',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property MCT can\'t be set as the property %s is already set. Only one property must be set among these properties: MCT, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set MCT value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TypeEcgMCT $mCT
     * @return \StructType\TypeDemarcheECG
     */
    public function setMCT(\StructType\TypeEcgMCT $mCT = null)
    {
        // validation for constraint: choice(VOF, VOI, VN, DUP, MCT)
        if ('' !== ($mCTChoiceErrorMessage = self::validateMCTForChoiceConstraintsFromSetMCT($mCT))) {
            throw new \InvalidArgumentException($mCTChoiceErrorMessage, __LINE__);
        }
        if (is_null($mCT) || (is_array($mCT) && empty($mCT))) {
            unset($this->MCT);
        } else {
            $this->MCT = $mCT;
        }
        return $this;
    }
}
